
/**** SAS Programming 2́@vOt ********************/

/************* 1@͂ATvf[^̍쐬 **********************/
data  ex11;
input  subject $ gender $ math1 math2;
sum = math1 + math2;  
ave = mean(math1,math2);
if  ave>=80  then  grade="A";
else  if  ave>= 70  then grade= "B";
else  if  ave>= 60  then grade= "C";
else  grade = "F";
label  subject="wДԍ"  gender="" 
   math1="w1"  math2="w2" 
   sum="v_"   ave="ϓ_" 
   grade="" ; 
cards;
s002  m  89  68
s003  m  69  77
s004  f  54  68
s009  f  78   91
s012  f  91  96
s013  m  63  44
k021  m  80  80
k023  f  56  61
k024  m  72  79
k026  f  89   89
s103  m  91 100
s106  m  90  98
; 
run:

title  "Example ex11";
proc  print  data=ex11 ;
run; 
title  "Sorted by the grade" ;
proc  sort  data=ex11  ;
  by  grade;
proc  print  label;
run;

data  ex11a (drop=tmp);
 set  ex11 ;
length  dept  $  6. ;
tmp = substr(subject, 1, 1);
 put  "tmp= " tmp ;
 if  tmp="s"  then  dept= "w";
  else  if  tmp="k"  then  dept = "w";
  else  if  tmp="b"  then  dept = "";
  else  dept = "̑";
label  dept="w" ; 
proc  print  data = ex11a  label;
run;

/********* wx  surver f[^Zbg@*********/
options  noxsync  noxwait;
x  "C:\sas_study\student.xls";
filename  scfile   dde  "excel|student survey!r5c1:r30c6" ;

data  survey;
infile  scfile  dlm = '09'x  notab  dsd  missover  lrecl = 20000;
input  pin $  area $  ctime money sc career ; 
label  pin="wДԍ"   area="Z"  ctime="ʊw"
 money=""  sc="x"  career="iH"; 
informat  money  comma. ; 
format  money  yen.  ; 
run;
title "student survey";
proc print data=survey (obs=10); 
run;


proc  format ;
value  scfmt 1="ϖ"  2="" 3="" 4="s" 5="ϕs" ; 
value  careerfmt 1="AE"  2="iw" 3="" 4="̑" ; 
value  genderfmt  0="j"         1="" ;
value  smkfmt   0="iȂ"  1="i" ; 
value $  gfmt   "m"= "j"   "f" = "" ; 
run;

data survey;
 set survey;
 format sc scfmt.  career  careerfmt. ;
data  ex11;
 set  ex11;
 format   gender  $ gfmt.  ; 
run ; 
title "student survey";
proc print data=survey  label; run;
title  "Example ex11";
proc  print  data=ex11  label; run;

proc  format  ;
value  scfmt 1="ϖ"  2="" 3="" 4="s" 5="ϕs" ; 
value  careerfmt 1="AE"  2="iw" 3="" 4="̑" ; 
value  genderfmt  0="j"         1="" ;
value  smkfmt   0="iȂ"  1="i" ; 
value $  gfmt   "m"= "j"   "f" = "" ; 
run;

title ; 

/*******  Tvf[^̍쐬@I **********************/




title  " уOt";
proc  sgplot  data=ex11 ;
vbar  grade; 
run ;

title   h=2  "j math1 ϐ̐уOt";
title2  h=2  "쐬F &sysuserid  on  &sysdate9 " ;
proc  sgplot  data=ex11;
vbar  gender /  response=math1  stat=mean ;
run;

title  " уOt";
proc  sgplot  data=ex11 ;
vbar  grade / 
response= math1  
stat = mean
group = gender 
groupdisplay = cluster ; 
run ;


data gex212;
input  gender $  ave  up  low  area $  ;
cards;
f   10  13   5  _ސ   
f    9  13   6  t   
f   13  15  10  
m   13  15   5  _ސ  
m   11  13   5  t  
m   14  16   8  
;
run;

title "nʃOt" ; 
proc  sgplot  data=gex212; 
vbarparm  category=area  response=ave  /  group=gender;
run;

title "nʃOt" ; 
proc  sgplot  data=gex212;
hbarparm  category=area  response=ave  /  group=gender
limitupper=up  limitlower=low ;
run; 


title  "ѕʁ@ڍ׃Ot";
proc  sgplot  data= ex11;
vbar  grade /  response=math1  stat=mean ;
vline  grade /  response=math2  stat=mean  markers ;
run;



data  gex214; 
retain  year  1999 ; 
input  cost  price @@ ; 
year = year + 1 ; 
cards; 
89  100   87  100   89  101  90  102  
95  105   88  103   92  110  94  110 
96  115   97  120   99  120  100 120
100 125   120  130 
;
proc  print  data= gex214 ;
run;

title "2000`2013 NClrOt" ; 
proc  sgplot  data= gex214;
series  x=year  y=cost   / datalabel ;
series  x=year  y=price  / datalabel ;
run ; 

title "2000`2013 NClrOt" ; 
proc  sgplot  data=gex214;
series  x=year  y=cost /  
 datalabel  datalabelattrs= (size=3mm  Family=Arial) 
 markers  markerattrs=(symbol=TriangleDownFilled  Color=blue  size=3mm) ; 
series  x=year  y=price / 
 datalabel  datalabelattrs= (size=3mm  Family=Arial)
markers  markerattrs=(symbol=CircleFilled  Color=red  size=3mm) lineattrs=(pattern=42); 
xaxis values=(2000 to 2013 by 1) ;
run ; 


title "j math1 ϐ̔Ђ}" ;
proc  sgplot  data=ex11 ;
vbox  math1  /  category=gender ;
run ;

title "wȕ math1 ϐ̔Ђ}" ;
proc  sgplot  data=ex11a ;
vbox  math1  /
 category=dept  group=gender ; 
run ;


title  " Histogram for math1 and math2" ;  
proc  sgplot  data = ex11 ;
histogram  math1;
histogram  math2 /  transparency= 0.5 ;
run; 

title  "Histogram and Density curve" ;  
proc  sgplot  data = ex11 ;
histogram  math1 /  showbins ;
density  math1 ;
density  math1  /  type= kernel ;
keylegend  /  location=inside 
    position=topright ;
run ;


title  "Histogram and Density curve" ;  
proc  sgplot  data = ex11 ;
histogram  math1 / showbins;
density  math1 / type=normal ( mu=80 sigma=15)
 lineattrs= ( color=blue  pattern=1 ) ;
refline  75  55  / axis=x  lineattrs= (color=red  pattern=2 ) ;
run;



title  "Scatter plot using math1 and math2 by gender" ; 
proc  sgplot  data= ex11 ;
scatter  y=math1  x= math2  / group= gender  datalabel= subject;
run ;

title  "Scatter plot using math1 and math2 by gender" ; 
proc  sgplot  data= ex11 ;
scatter  y=math1  x= math2  / 
   group= gender  datalabel= subject  markerattrs=(size=3mm)
 datalabelattrs=( size=3mm  Family=Arial) ;
 run ;



title  "Regression plot"  ; 
proc  sgplot  data=ex11;
reg  y=math2  x= math1 /  group= gender  datalabel= subject  ;
run ;

title  "Regression plot"  ; 
proc  sgplot  data=ex11;
reg  y=math2  x= math1 /  
group= gender  datalabel= subject  markerattrs=(size=5mm) ;
xaxis values=(50 to 100 by 5);
yaxis values=(40 to 100 by 10);
run ;

title  "Regression plot"  ; 
proc  sgplot  data= ex11;
reg  y=math2  x= math1 / clm cli  alpha= 0.1 ;
refline  60  80 ;
run ;



title  "Loess Curve " ;
proc  sgplot  data= ex11 ;
loess  y=math2  x=math1 / degree=2;
run ;

title  "Penalized B-spline curve ";
proc  sgplot  data= ex11;
pbspline  x=math1  y=math2  / clm;
refline  ave ;
run;



title  "vector using math1 and math2 " ;
proc  sgplot  data= ex11 ;
vector  x=math1  y=math2 /  xorigin=70  yorigin=60 arrowheadshape=barbed
group= gender  datalabel= subject  
datalabelattrs=( size=5mm  Family=Arial) ; 
run ;


/*******   2.2  Ot̔riSGSCATTERvVWj   ******************/
data add;
input subject $ kokugo @@;
label kokugo = "" ; 
cards;
s002  70 	s012  99	k024  86
s003  68	s013  67	k026  90
s004  55	k021  95	s103  89
s009  88	k023  86	s106  90
;

proc sort data=ex11;by subject;
proc sort data=add; by subject;
data ex11c;
merge ex11 add; by subject;
proc print data =ex11c label ;run;



title  "2 scatter plots" ; 
proc  sgscatter  data=ex11c;
plot  math1*kokugo  math2*kokugo  / 
group= gender   grid  reg= ( nogroup  clm  cli )   datalabel= subject 
markerattrs= (size=4mm);
run ; 

title  "2 Scatter plots"; 
proc  sgscatter  data=ex11c;
compare  y= (math1  math2)  x= kokugo /
  group= gender  grid  reg= (nogroup  clm  cli)  datalabel= subject ;
run;


title  "Scatter matrix of scores of  math1,math2 and kokugo "; 
proc  sgscatter  data= ex11c;
matrix  math1  math2  kokugo  /  group=gender  diagonal= ( normal  histogram )
markerattrs= (size=12) ;
run ;


title  "Scatter matrix of scores of  math1,math2 and kokugo "; 
proc  sgscatter  data= ex11c;
matrix  math1  math2  kokugo  /  ellipse= (alpha=0.01  type=mean )
markerattrs = (size=12  color= blue  symbol= triangle ) ;
run ;




/****** 2.3  ޕϐ̒lŔrOti SGPANELvVWj*******/
title  "plot using math1 and math2 by gender " ;
proc  sgpanel  data=ex11;
panelby  gender ; 
reg  x=math1  y=math2  / clm;
run;

title  " Distribution for math1 by gender " ;
proc  sgpanel  data=ex11;
panelby gender ; 
histogram  math1 ;
density  math1; 
run; 

title   "Histogram for math1 and math2";
title2  "by grade" ;
proc  sgpanel  data=ex11;
panelby  grade;
vbar  gender  /  response=math1  stat=mean transparency=0.3  ;
vbar  gender  /  response=math2  stat=mean transparency=0.3   barwidth=0.5  ;
run ;




proc  sgpanel  data=ex11;
panelby  grade  /  columns=4 ;
vbar  gender  /  response=math1  stat=mean  transparency=0.3  ;
vbar  gender  /  response=math2  stat=mean  transparency=0.3   barwidth=0.5  ;
run ;



/********Otev[g𗘗pOti SGRENDERvVWj *******/
data  cone ;
do  k =  -2  to  2  by  0.25 ;
  do  m =  -2  to  2  by  0.25 ;
    n=  sqrt( k*k  + m*m ) ;
   output ;
  end ;  
end ;
run;


proc  template ;
define  statgraph  sfgraph ;
 begingraph ;
entrytitle  "Cone 3D Plot" ;
 layout  overlay3d ;
    surfaceplotparm  x=k  y=m  z=n ;
endlayout ;
  endgraph ;
 end ;
run ;

proc  sgrender  data= cone  template= sfgraph ;
run;


proc  template ;
define  statgraph  sfgraph ;
 begingraph ;
entrytitle  "Cone 3D Plot" ;
 layout  overlay3d ;
    surfaceplotparm  x=k  y=m  z=n/
surfacetype= wireframe  
fillattrs=(color=SlateBlue) ;
;
endlayout ;
  endgraph ;
 end ;
run ;

proc  sgrender  data= cone  template= sfgraph ;
run;


proc  template ;
define  statgraph  sfgraph ;
 begingraph ;
entrytitle  "Cone 3D Plot" ;
 layout  overlay3d ;
bihistogram3dparm  x=k  y=m  z=n ; 
endlayout ;
  endgraph ;
 end ;
run ;

proc  sgrender  data= cone  template= sfgraph ;
run;

proc  template ;
define  statgraph  ScatterReg ;
begingraph ;
entrytitle  "Scatter Plot for math1 and math2";
entrytitle  "Reported by &sysuserid on &sysdate9";
layout  overlay ;
modelband  "myclm" ;
scatterplot  y=math1  x=math2 / markerattrs=(size=15)
datalabel=subject  datalabelattrs=(size=15)  group=gender ;
regressionplot  y=math1  x=math2 / clm="myclm"  alpha=0.01
degree=1  name='line'  legendlabel= 'Linear Fit' ;
endlayout ;
endgraph ;
end ;
run ;


proc  sgrender  data=ex11  
template=scatterreg ;
run;


proc  template ;
define  statgraph  Panel3g ;
begingraph ;
 entrytitle  "math1̓_";
layout  lattice / rows=3  columns=1 ;

layout  overlay  /
yaxisopts=(offsetmin=.15) xaxisopts=(label='math2̓_');
     histogram  math2 / binstart=0  BINwidth=10 ;
     fringeplot  math2 ;
     densityplot  math2  / normal( );
endlayout;
layout  overlay  / xaxisopts=(label='math2̓_');
     boxplot  y= math2 / orient= horizontal;
endlayout ;

layout overlay /
yaxisopts=(label='math2̓_') xaxisopts=(label='math1̓_');
     scatterplot  y=math2  x=math1 / 
markercharacter= subject 
         name='color'  markercolorgradient= sum;
     continuouslegend  'color' /  title='v_' ;
     regressionplot  y=math2  x=math1 ;
endlayout ;
endlayout;
endgraph ;
end ;

proc  sgrender  data= ex11  template= panel3g ;
run;


proc  template ;
define  statgraph  ScatterReg2 ;
dynamic  VARX  VARY  DEG ;
begingraph ;
entrytitle  "Scatter Plot for " VARX " and " VARY;
entrytitle "Reported  by  &sysuserid  on  &sysdate9" ;
layout  overlay ;
modelband  "myclm";
scatterplot   y=VARY  x= VARX  /  markerattrs=(size=15 ) 
datalabel= subject  datalabelattrs=(size=15)  group=gender ;
regressionplot  y=VARY  x= VARX  /  clm="myclm"  alpha=0.01
degree=DEG  name= 'line'  legendlabel= 'Linear Fit' ;
endlayout ;
endgraph ;
end;
run;

proc  sgrender  data= ex11  template= ScatterReg2;
dynamic  vary="math1" varx="math2" deg= 3 ; 
run ;


proc  template;
define statgraph  sgbutterfly;
dynamic  _HL  _LEFT  _HR  _RIGHT;
begingraph;
   entrytitle halign=center _LEFT"" _RIGHT "̔rOt";
   entryfootnote halign=left "쐬FgV (&sysuserid) , tF&sysdate9 &systime";
   layout lattice / rowdatarange=data columndatarange=data columns=2 rowgutter=10
columngutter=10 columnweights=(0.5 0.5);
      layout overlay / xaxisopts=( reverse=true) yaxisopts=( display=(LINE));
      barchart x=_HL y=_LEFT / name='bar(h)' datatransparency=0.5
stat=mean  orient=horizontal groupdisplay=Stack clusterwidth=1.0;
      endlayout;
      layout overlay / yaxisopts=( display=(TICKVALUES LINE));
      barchart x=_HR y=_RIGHT / name='bar(h)2' datatransparency=0.5 
stat=mean  orient=horizontal discreteoffset=0.08 fillattrs=GraphData2;
      endlayout;
   endlayout;
endgraph;
end;
run;

data gex241;
input age female male @@ ;
cards;
10  10  11    20  13  13    30  14  26
40  26  28    50  20  23    60  13  20
;
run;

proc  sgrender  data=gex241  template=sgbutterfly;
dynamic  _HL="age"  _LEFT="male"  _HR="age"  _RIGHT="female";
run;

proc  sgrender  data=survey  template=sgbutterfly;
dynamic  _HL="sc"  _LEFT="money"  _HR="sc"  _RIGHT="ctime" ;
run;



/***** t^@*****************************************/
ods  listing  style=Journal ;
title " histogram and density curve"; 
proc  sgplot  data= ex11;
histogram math1;
density  math1;
run ;


data  gexB242 ;
input   a  b  web $ 30. ;
datalines;
30  10   http://www.tuniv.ac.jp/
20  15   http://www.abc.co.jp/
25  20   http://www.mmm.co.jp/
;
run;

ods  graphics  on  /  imagemap=on ;
ods  html  body='text.html' ;
proc  sgplot  data= gexB242; 
 scatter  y= a  x= b /  url= web ;
run ;
ods  html  close ;


title  "Graph testing 3 " ; 
ods  rtf ;
proc  sgplot  data=ex11 ;
 scatter  y=math2  x=math1  ;
run ;
ods  _all_  close;


ods html; 

/******** K *************************************/
/*** (ex2.1)  **************************************/
data e2a;
do i=1 to 100;
x=rand("normal",2,5);
grade=(x ge 7)+(x ge 2)+(x ge -3);
select;
when (i<=25) group="A";
when (i<=50) group="B";
when (i<=75) group="C";
otherwise group="D";
end;
output;
end;
run;


proc sgplot data=e2a;
hbar grade;
run;

proc sgplot data=e2a;
histogram x;
density x;
run;

proc sgplot data=e2a;
vbox x /category=group;
run;

proc sgpanel data=e2a;
panelby group;
histogram x;
density x;
run;


/*** (ex2.2)  *****************************************/
proc  sort   data=survey  out=temp;
 by  ctime;
 run;
proc  sgplot  data=temp;
series  y= money  x= ctime /  datalabel=pin ; 
 run ;
proc  sgplot  data=survey;
 bubble  x=sc  y=area  size=money  / datalabel= money;
format  sc  scfmt. ; 
where  area  in  ("", "_ސ", "", "t") ; 
run ;

/*** (ex2.3)  *****************************************/
proc  sgplot  data= gex214;
step  x=year  y=cost  / datalabel ;
step  x=year  y=price  / datalabel ;
run ;

proc  sgplot  data= gex214;
step x=year  y=cost  / datalabel ;
step  x=year  y=price  / datalabel ;
 where  2005 <= year ; 
 xaxis values= (2005 to 2013 by 1) ; 
run ;

proc  sgrender  data=gex214  template=sgbutterfly;
dynamic  _HL="year"  _LEFT="cost"  _HR="year"  _RIGHT="price";
run;



data cov (type=cov);
infile cards;
input _type_ $ _name_  $ x1 x2 x3;
cards;
cov  x1   14  8    0
cov  x2   8    5    -2
cov  x3   0   -2   10
;
run;
proc simnormal data=cov (type=cov) out=sim numreal=200 seed=0;
var x1 x2 x3;
run;

proc sgscatter data=sim;
matrix x1 x2 x3 / diagonal=(normal histogram);
run;
