/********   SAS Programming   t^  D@                          ****************/


/*****  D.1  health f[^Zbg쐬@                   *******/
/*****@@сAtH[}bg쐬vO          *******/
/*                                                                */
/************************************************/

/***** health f[^Zbg̍쐬vO           ********/
data health;
input  id $  age  gender height	weight	sleeping  smoking  nsmoking;
cards; 
s001        20     1      162	  50	   7	   0	     0
s002 	    20 	   0	    .	   .	   7	   0	     0
s003	    20	   0 	  178	  74	   4	   1	    10
s004   	    20	   1	  165	  66	   5	   1	     5
s005	    20     0	  173	  85	   8	   1	     7
s006	    21	   1	  170	  65	   8       0	     0
s007	    21	   0	  180	  78	   5	   1	     5
s008  	    23	   0	  181	  75	   7	   1	     3
s009 	    23     1	  166	  54	   6	   0	     0
s010	    20     0	  175	  59	   8	   0	     0
s011	    21     0	  174	  65	   8	   0	     7
s012	    21 	   1	  155	  47	   6	   1	     5
s013	    21 	   0	  166	  57	   8	   1	     3
s014	    20	   1	    .	   .	   6	   0	     0
s015	    23     0	  165	  60	   6	   1	    10
k021	    20     0	    .	  75	   8	   0	     0
k022	    21	   0	  167	  68	   9	   0	     0
k023	    21	   1	  160	  50	   7	   0	     0
k024	    23	   0	  170	  78	   6	   1	     3
b025	    25	   0	  171	  45	   5	   1	    15
k026	    22	   1	  159	  53	   6	   1	     5
s103	    41     0	  172	  80	   5	   1	    40
s104	    29	   0	  177	  69	   7	   0	     0
s105	    30     0	  166	  58	   5	   1	    20
s106	    31	   0	  169	  57	   6	   1	    30
;
run;
/***********************************************************/

/***  tH[}bgJ^O쐬 ***********************************/
/***  tH[}bg health f[^ZbgɊ蓖Ă *******/
proc  format ;
value  genderfmt  0="j"         1="" ;
value  smkfmt   0="iȂ"  1="i" ; 
run;

data  health ;
 set  health;
 label  age="N"  gender=""  height= "g"  weight="̏d"
        sleeping= ""        smoking="i"   
        nsmoking= "P̋i{" ;
format  gender   genderfmt.  ; 
format  smoking  smkfmt.  ; 
 run;
/***********************************************************/

/***  health f[^Zbg̓e\ *************************/
title  "health data" ;
proc  print  data=health  label;
run;
/**********************************************************/

title; 


/*****     SASf[^Zbg쐬vO                     ******/
/*****     D. 2   survey@f[^Zbg̍쐬                  ******/
/*****         survey ptH[}bg쐬                        ******/
/**************************************************/


/*****    survey@f[^Zbg̍쐬                       *******/
data  survey;
input  pin $  area $  ctime  money  sc  career ; 
label  pin="wДԍ"   area="Z"   ctime="ʊw"
       money=""   sc="x"   career="iH"  ; 
informat  money  comma.  ; 
format    money  yen.  ; 
cards;
s001              60   1,000       1       1
s002              90     300       1       2
s003              70   3,000       1       2
s004    _ސ        65   5,000       1       1
s005               5     300       4       1
s006              15   3,000       5       2
s007    t          30  10,000       5       4
s008    _ސ        80  15,000       5       4
s009    ̑       105   2,000       3       1
s010              55   5,000       4       1
s011              60  20,000       3       4
s012    Qn         100   8,000       1       1
s013    Ȗ         100   3,000       3       4
s014    ̑        90  13,000       2       1
s015              50     500       1       1
k021              40   5,000       2       2
k022              45   5,000       4       2
k023    Ȗ         105  13,000       3       4
k024    t          60  10,000       1       1
k025    ̑        90   2,000       3       1
k026              30   4,000       4       2
s103    _ސ        45  20,000       2       3
s104    _ސ        35  30,000       3       4
s105              60  45,000       4       1
s106              10   5,000       2       2
;
run;
/***********************************************************/



/***  survey ptH[}bgJ^O쐬  **************************/
/***  tH[}bg survey@f[^Zbgւ̊蓖 @@@*********/
proc  format ;
value  scfmt 1="ϖ"  2="" 3="" 4="s" 5="ϕs" ; 
value  careerfmt 1="AE"  2="iw" 3="" 4="̑" ; 
run;

data survey;
 set survey;
 format sc scfmt.  career  careerfmt. ;
run;
/************************************************************/


/***** survey f[^Zbg̓e̕\ ****************************/
title "student survey";
proc print data=survey  label; 
run;
/************************************************************/

title; 
